#!/util/bin/perl5
#
# Functions to talk to a news server.
# By Davin Milun
# Sun Jul  9 16:06:06 EDT 1995
# Release: thruck 1.0 (first public release)
#
# Based strongly on:
# read-comics Version 0.11, (January 17, 1994)
# Author: Jennifer Myers <jmyers@eecs.nwu.edu>
#######################################################################


# require 'sys/socket.ph';  
# The following only work correctly for Solaris 2.x
# The correct solution is to use the socket.ph require above.
eval 'sub AF_INET {2;}';
eval 'sub PF_INET {2;}';
eval 'sub SOCK_STREAM {2;}';

sub body_cmd {
        local($name)=@_;
        local(@ret);
		
        print NNTP "BODY $name\n";
        $_=<NNTP>;
        if (!/^222 /)
                {
                print STDOUT "body cmd problems ($name):$_";
                do quit_cmd(1);
                }
        @ret=&getlines();       
        return(@ret);
        }

sub head_cmd {
        local($name,$headref)=@_;
        local(@ret);
		
        print NNTP "HEAD $name\n";
        $_=<NNTP>;
        if (!/^221 /)
                {
#               print STDOUT "head cmd problems ($name):$_";
                return 0;
                }
        @$headref=&getlines();
        return(1);
        }

sub xhdr_cmd {
        local($a,$b)=@_;

        print NNTP "XHDR Subject $a-$b\n";
        $_=<NNTP>;
        if (!/^221 /) {
                print STDOUT "xhdr cmd problems\n";
                if (/^500 /) {
                        do manual_xhdr_cmd($a,$b);
                } else {
                        do quit_cmd();
		}
                return;
        }
        @subject=&getlines();      
}

sub manual_xhdr_cmd {
        local($a,$b)=@_;
        local($i,@s,$j);

        $#subject=$[;
        foreach $i ($a .. $b) {
                print NNTP "HEAD $i\n";
                $_=<NNTP>;
	        if (/^221 /) {
                        @s=grep(/^Subject: /,&getlines());
                        print STDOUT "no Subject: line in article $i\n"
                                if ($#s < 0);
                        $s[0] =~ /^Subject: (.*)/;
                        push(@subject,"$i $1");
                } else {
                        print "$_";
                }
        }
}

sub getlines {
        local(@ret);

        while (<NNTP>) {
                if (/^\./ && (!/^\.\./)) {
                        chop;
                        last;
                }
                s/\015//g;
                push(@ret,$_);
        }
        return(@ret);
}

sub quit_cmd {
        local($code)=@_;
        print NNTP "QUIT\n";
        $_=<NNTP>;
        print STDOUT "close bad:$_" unless (/^205 /);
        die("Server died with code $code");
}

sub group_cmd {
	my($group)=@_;
        print NNTP "GROUP $group\n";
        $_=<NNTP>;

        split;
        ($code,$num,$first,$last,$group)=@_;
        if ($code != 211) {
                print STDOUT "group cmd problems:$_";
                do quit_cmd(1);
        }
        return($first,$last);
}

sub dokill {
        kill(9,$child) if $child;
}

sub startnntp {
        local($name)=@_;

        $SIG{'INT'}='dokill';

        $sockaddr='Sna4x8';
        chop($hostname=`hostname`);

        ($n,$aliases,$proto)=getprotobyname('tcp');
        ($n,$aliases,$port)=getservbyname('nntp','tcp');
        ($n,$aliases,$type,$len,$thisaddr)=gethostbyname($hostname);
        ($n,$aliases,$type,$len,$thataddr)=gethostbyname($name);
        $this=pack($sockaddr,&AF_INET,0,$thisaddr);
        $that=pack($sockaddr,&AF_INET,$port,$thataddr);

        socket(NNTP,&PF_INET,&SOCK_STREAM,$proto) || die "socket: $!";
        bind(NNTP,$this) || die "bind: $!";
        connect(NNTP,$that) || die "connect: $!";

        select(NNTP); $|=1;
        select(STDIN); $|=1;
        select(STDOUT); $|=1;
}

sub read_nntp_header {
        while (<NNTP>) {
                last if (/^200 /);
                last if (/^201 /);
                exit(1) if (/^400 /);
        }
}

1;
